<html>
<head>
<title>Ogre::WorkQueue::RequestHandler Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1WorkQueue.html">WorkQueue</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html">RequestHandler</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::WorkQueue::RequestHandler Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::WorkQueue::RequestHandler" -->
<p>Interface definition for a handler of requests.  
 <a href="classOgre_1_1WorkQueue_1_1RequestHandler.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::WorkQueue::RequestHandler:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1WorkQueue_1_1RequestHandler__inherit__graph.gif" border="0" usemap="#Ogre_1_1WorkQueue_1_1RequestHandler_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1WorkQueue_1_1RequestHandler_inherit__map" id="Ogre_1_1WorkQueue_1_1RequestHandler_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1Page.html" title="Page class." alt="" coords="5,83,93,112"/><area shape="rect" id="node5" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread." alt="" coords="117,83,339,112"/><area shape="rect" id="node7" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain." alt="" coords="363,83,461,112"/><area shape="rect" id="node9" href="classOgre_1_1TerrainGroup.html" title="Helper class to assist you in managing multiple terrain instances that are connected to each other..." alt="" coords="485,83,619,112"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1WorkQueue_1_1RequestHandler-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a37f35aaa5935b91a180d92e5243fccb7">RequestHandler</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a0d7c8fced3825d323b12b5dbd167bf83">~RequestHandler</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#adf4a5093c7b789352a0a44629490bc87">canHandleRequest</a> (const <a class="el" href="classOgre_1_1WorkQueue_1_1Request.html">Request</a> *req, const <a class="el" href="classOgre_1_1WorkQueue.html">WorkQueue</a> *srcQ)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether this handler can process a given request.  <a href="#adf4a5093c7b789352a0a44629490bc87"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structOgre_1_1WorkQueue_1_1Response.html">Response</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#adf4cfa2660e7acf3a74751309855b39e">handleRequest</a> (const <a class="el" href="classOgre_1_1WorkQueue_1_1Request.html">Request</a> *req, const <a class="el" href="classOgre_1_1WorkQueue.html">WorkQueue</a> *srcQ)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The handler method every subclass must implement.  <a href="#adf4cfa2660e7acf3a74751309855b39e"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Interface definition for a handler of requests. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>User classes are expected to implement this interface in order to process requests on the queue. It's important to realise that the calls to this class may be in a separate thread to the main render context, and as such it may not be possible to make rendersystem or other GPU-dependent calls in this handler. You can only do so if the queue was created with 'workersCanAccessRenderSystem' set to true, and OGRE_THREAD_SUPPORT=1, but this puts extra strain on the thread safety of the render system and is not recommended. It is best to perform CPU-side work in these handlers and let the response handler transfer results to the GPU in the main render thread. </dd></dl>

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00160">160</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a37f35aaa5935b91a180d92e5243fccb7"></a><!-- doxytag: member="Ogre::WorkQueue::RequestHandler::RequestHandler" ref="a37f35aaa5935b91a180d92e5243fccb7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a37f35aaa5935b91a180d92e5243fccb7">Ogre::WorkQueue::RequestHandler::RequestHandler</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00163">163</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0d7c8fced3825d323b12b5dbd167bf83"></a><!-- doxytag: member="Ogre::WorkQueue::RequestHandler::~RequestHandler" ref="a0d7c8fced3825d323b12b5dbd167bf83" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a0d7c8fced3825d323b12b5dbd167bf83">Ogre::WorkQueue::RequestHandler::~RequestHandler</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00164">164</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="adf4a5093c7b789352a0a44629490bc87"></a><!-- doxytag: member="Ogre::WorkQueue::RequestHandler::canHandleRequest" ref="adf4a5093c7b789352a0a44629490bc87" args="(const Request *req, const WorkQueue *srcQ)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#adf4a5093c7b789352a0a44629490bc87">Ogre::WorkQueue::RequestHandler::canHandleRequest</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1WorkQueue_1_1Request.html">Request</a> *&#160;</td>
          <td class="paramname"><em>req</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1WorkQueue.html">WorkQueue</a> *&#160;</td>
          <td class="paramname"><em>srcQ</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return whether this handler can process a given request. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Defaults to true, but if you wish to add several handlers each of which deal with different types of request, you can override this method. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1Terrain.html#a22196f59f8f761e7fc4bea11db488252">Ogre::Terrain</a>, <a class="el" href="classOgre_1_1TerrainGroup.html#a008f51c172bd858cca8763af865f3fa1">Ogre::TerrainGroup</a>, <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#adc005af8b5c25bcfd6e39d4d5255d754">Ogre::ResourceBackgroundQueue</a>, and <a class="el" href="classOgre_1_1Page.html#a858b194d988c22e52516f03fd50d0062">Ogre::Page</a>.</p>

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00172">172</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

<p>References <a class="el" href="OgreWorkQueue_8h_source.html#l00116">Ogre::WorkQueue::Request::getAborted()</a>.</p>

</div>
</div>
<a class="anchor" id="adf4cfa2660e7acf3a74751309855b39e"></a><!-- doxytag: member="Ogre::WorkQueue::RequestHandler::handleRequest" ref="adf4cfa2660e7acf3a74751309855b39e" args="(const Request *req, const WorkQueue *srcQ)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structOgre_1_1WorkQueue_1_1Response.html">Response</a>* <a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#adf4cfa2660e7acf3a74751309855b39e">Ogre::WorkQueue::RequestHandler::handleRequest</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1WorkQueue_1_1Request.html">Request</a> *&#160;</td>
          <td class="paramname"><em>req</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1WorkQueue.html">WorkQueue</a> *&#160;</td>
          <td class="paramname"><em>srcQ</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The handler method every subclass must implement. </p>
<p>If a failure is encountered, return a <a class="el" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a> with a failure result rather than raise an exception. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">req</td><td>The <a class="el" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a> structure, which is effectively owned by the handler during this call. It must be attached to the returned <a class="el" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a> regardless of success or failure. </td></tr>
    <tr><td class="paramname">srcQ</td><td>The work queue that this request originated from </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Pointer to a <a class="el" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a> object - the caller is responsible for deleting the object. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1Terrain.html#a00a3600acc9fb758f8890f2c0877f62e">Ogre::Terrain</a>, <a class="el" href="classOgre_1_1TerrainGroup.html#a28e769b1bb49906de087be411ae97001">Ogre::TerrainGroup</a>, <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#ab62b4ac5538f5f96123ba2491c3af284">Ogre::ResourceBackgroundQueue</a>, and <a class="el" href="classOgre_1_1Page.html#a80e1feed0673e75e4c56660f4be9fd00">Ogre::Page</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:10
</p>
</body>
</html>
